
Public Class FrmExcel
    Inherits System.Windows.Forms.Form

#Region " Codice generato da Progettazione Windows Form "

    Public Sub New()
        MyBase.New()

        'Chiamata richiesta da Progettazione Windows Form.
        InitializeComponent()

        'Aggiungere le eventuali istruzioni di inizializzazione dopo la chiamata a InitializeComponent()

    End Sub

    'Form esegue l'override del metodo Dispose per pulire l'elenco dei componenti.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Richiesto da Progettazione Windows Form
    Private components As System.ComponentModel.IContainer

    'NOTA: la procedura che segue  richiesta da Progettazione Windows Form.
    'Pu essere modificata in Progettazione Windows Form.  
    'Non modificarla nell'editor del codice.
    Friend WithEvents BtnEsci As System.Windows.Forms.Button
    Friend WithEvents btnCrea As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.btnCrea = New System.Windows.Forms.Button()
        Me.BtnEsci = New System.Windows.Forms.Button()
        Me.SuspendLayout()
        '
        'btnCrea
        '
        Me.btnCrea.Location = New System.Drawing.Point(120, 152)
        Me.btnCrea.Name = "btnCrea"
        Me.btnCrea.TabIndex = 0
        Me.btnCrea.Text = "Genera"
        '
        'BtnEsci
        '
        Me.BtnEsci.Location = New System.Drawing.Point(200, 152)
        Me.BtnEsci.Name = "BtnEsci"
        Me.BtnEsci.TabIndex = 1
        Me.BtnEsci.Text = "&Esci"
        '
        'FrmExcel
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(282, 189)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.BtnEsci, Me.btnCrea})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "FrmExcel"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Esempio di come usare excel da VB.Net"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub BtnEsci_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnEsci.Click
        Me.Close()

    End Sub

    Private Sub btnCrea_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCrea.Click
        'creo l'oggetto excel application il programma excel.
        Dim XlaDati As Excel.Application
        'creo l'oggetto per la gestione della cartella di lavoro
        Dim XlwbDati As Excel.Workbook
        'creo l'oggetto per la gestione del foglio di excel(es. foglio uno, foglio due)
        Dim XlshDati As Excel.Worksheet
        'instanzio l'oggetto application
        XlaDati = CreateObject("Excel.Application")
        'gestione degli errori
        Try
            'lo rendo visibile
            XlaDati.Visible = True
            'aggiungo una nuova cartella excel
            XlwbDati = XlaDati.Workbooks.Add
            'Mi posiziono sul foglio attivo
            XlshDati = XlwbDati.ActiveSheet
            'contatore di excel
            Dim IntConta As Integer
            'eventuali titolo array
            Dim StrTitoloExcel() As String = {"Cognome", "Nome", "Voto", "Citt"}
            'Imposto il nome del foglio
            XlshDati.Name = "Esempio"
            'valorizzo la prima riga
            For IntConta = 0 To 3
                With XlshDati.Cells(1, IntConta + 1)
                    'inserisco il valore
                    .value = StrTitoloExcel(IntConta)
                    'lo rendo in grassetto
                    .font.bold = True
                    'gli do la dimensione
                    .font.size = 14
                    'rendo la cella di dimensioni uguali al testo (autosize)
                    .EntireColumn.autofit()
                End With
            Next
            'variabile che gestisce i dati anzich un array possiamo utilizzare un dataset
            Dim StrNomi(3, 4) As String
            'per la colonna cognome
            StrNomi(0, 1) = "Foti"
            StrNomi(1, 1) = "Mattei"
            StrNomi(2, 1) = "Foti"
            'colonna nome
            StrNomi(0, 2) = "Olga"
            StrNomi(1, 2) = "Emanuele"
            StrNomi(2, 2) = "Pino"
            'per la colonna voti
            StrNomi(0, 3) = "8"
            StrNomi(1, 3) = "6"
            StrNomi(2, 3) = "4"
            'per la colonna citt
            StrNomi(0, 4) = "Reggio Calabria"
            StrNomi(1, 4) = "Roma"
            StrNomi(2, 4) = "Milano"
            'variabile per la gestione delle righe
            Dim IntContaRighe, IntContaColonne As Integer
            'Ciclo per ogni riga
            For IntContaRighe = 0 To 3
                'ciclo per ogni colonna dove ci sono i dati
                For IntContaColonne = 1 To 4
                    'le matrici inziano con 0 per ci pi due per le righe di excel 
                    With XlshDati.Cells(IntContaRighe + 2, IntContaColonne)
                        .value = StrNomi(IntContaRighe, IntContaColonne)
                        .EntireColumn.autofit()
                    End With
                Next
            Next
            'Seleziono i dati da utilizzare nel grafico
            XlwbDati.Sheets("Esempio").range("C2:C4", "B2:B4").select()
            With XlshDati.Application
                'aggiungo un grafico
                .Charts.Add()
                'il tipo di grafico
                .ActiveChart.ChartType = Excel.XlChartType.xl3DColumnClustered
                'i dati per il grafico
                .ActiveChart.SetSourceData(Source:=XlwbDati.Sheets("Esempio").range("C2:C4", "B2:B4") _
            , PlotBy:="xlColumns")
                'Indico la leggenda
                .ActiveChart.SeriesCollection(1).Name = "=""Voti"""
                'Imposto il grafico nella pagine corrente
                .ActiveChart.Location(Where:=Excel.XlChartLocation.xlLocationAsObject, Name:="Esempio")
                'Imposto Il titolo del grafico
                .ActiveChart.HasTitle = True
                .ActiveChart.ChartTitle.Characters.Text = "Esempio Excel"
                'Imposto l'etichett per l'asse x
                .ActiveChart.Axes(Excel.XlAxisType.xlCategory, Excel.XlAxisGroup.xlPrimary).HasTitle = True
                .ActiveChart.Axes(Excel.XlAxisType.xlCategory, Excel.XlAxisGroup.xlPrimary).AxisTitle.Characters.Text = "Nomi"
                'imposto l'echtetta per l'asse y
                .ActiveChart.Axes(Excel.XlAxisType.xlValue, Excel.XlAxisGroup.xlPrimary).HasTitle = True
                .ActiveChart.Axes(Excel.XlAxisType.xlValue, Excel.XlAxisGroup.xlPrimary).AxisTitle.Characters.Text = "Voti"
            End With
            'salvo il file
            XlaDati.ActiveWorkbook.SaveAs(Environment.CurrentDirectory & "\EsempioExcel.xls", , , , , , Excel.XlSaveAsAccessMode.xlExclusive)
        Catch ex As Exception
            MessageBox.Show(ex.Message, "Programma Excel", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Finally
            '2distruggo" gli oggetti creati
            XlshDati = Nothing
            XlwbDati = Nothing
            XlaDati = Nothing
        End Try



    End Sub
End Class
